function pvbb_includeScript(scriptUrl) {
    pvbb_log("Performing dynamic inclusion of " + scriptUrl);
    var headElement = document.getElementsByTagName('head').item(0);
    if (headElement) {
       var js = document.createElement('script');
       js.setAttribute('language', 'javascript');
       js.setAttribute('type', 'text/javascript');
       js.setAttribute('src', scriptUrl);
       js.onerror = function() { pvbb_scriptLoadError(scriptUrl); }

       headElement.appendChild(js);
    }
}

function pvbb_jsonEscapeStr(str) {
    // JSON-escapes backslashes and double quotes in a string
    return (str+'').replace(/([\\"])/g, "\\$1").replace(/\0/g, "\\0");
}

//
// Platform bridge functions
//

function pvbb_log(str) {
    window.HTMLOUT.log(str);
}

function pvbb_finishJSSync(invocID, retval) {
    window.HTMLOUT.finishJSSync(invocID, retval);
}

function pvbb_beamURL(url, metadataStr) {
    return window.HTMLOUT.beamURL(url, metadataStr);
}


function pvbb_beamPlayReadyURL(elem) {
    var jsonString;
    var url = elem.parentNode.getAttributeNode("data-href");
    if(url == null)
    {
        return null;
    }
    	
    jsonString = '{"url" : "' + pvbb_jsonEscapeStr(url.value);
    
       var contentid = elem.parentNode.getAttributeNode("data-content-id");
       if (contentid != null)
       {
         pvbb_log("page_init.js - HTML5 video content-id found ");
	 jsonString = jsonString + '",' + '"data-content-id" : "' + pvbb_jsonEscapeStr(contentid.value);
       }


       var mime = elem.parentNode.getAttributeNode("data-mime-type");
       if (mime != null)
       {
          jsonString = jsonString + '",' + '"data-mime-type" : "' + pvbb_jsonEscapeStr(mime.value);
       }

       var title = elem.parentNode.getAttributeNode("data-title");
       if (title != null)
       {
          jsonString = jsonString + '",' + '"title" : "' + pvbb_jsonEscapeStr(title.value);
       }
       
       var title = elem.parentNode.getAttributeNode("data-playnow");
       if (title != null)
       {
          jsonString = jsonString + '",' + '"data-playnow" : "' + pvbb_jsonEscapeStr(title.value);
       }
                           
       jsonString = jsonString + '"}';

    return window.HTMLOUT.beamPlayReadyURL(jsonString);
}

function pvbb_redecorate(delayMS) {
    window.HTMLOUT.redecorate(delayMS);
}

function pvbb_scriptLoaded(pageLoadID, scriptName, pageArgs) {
    window.HTMLOUT.scriptLoaded(pageLoadID, scriptName, pageArgs);
}

function pvbb_scriptLoadError(scriptUrl) {
    window.HTMLOUT.scriptLoadError(pvbb_pageLoadID, scriptUrl);
}

function pvbb_historyChanged(historyArgs) {
    window.HTMLOUT.historyChanged(historyArgs);
}

function pvbb_getMediaServersInfo() {
    return window.HTMLOUT.getMediaServersInfo();
}

function pvbb_transformRSSDoc() {
    pvbb_log("Transforming RSS doc to HTML");

    // Clear XML from page and add a waiting message.  Do it in a timeout so that
    // the DOM refreshes immediately.
    setTimeout(function() {
           var rootElement = document.documentElement;
           while (rootElement.hasChildNodes()) {
               rootElement.removeChild(rootElement.lastChild);
           }
           var newText = document.createTextNode("Reformatting, please wait...");
           rootElement.appendChild(newText);
        }, 0);

    // Now replace the page with a transformed HTML version
    setTimeout(function() {
            var transformUri = "http://cache.twonky.com/x" + document.location.href.split(':/')[1];
            document.location.replace(transformUri);
        }, 0);
}

function pvbb_pageInit()
{
    if (document.documentElement.nodeName == 'rss') {
        pvbb_transformRSSDoc();
    } else {
        // The WebView included with Ice Cream Sandwich wraps XML docs in an HTML parent, with the
        // original XML inside of a div with id "webkit-xml-viewer-source-xml", so check for that layout.
        var xmlViewer = document.getElementById('webkit-xml-viewer-source-xml');
        if (xmlViewer) {
            var rssNodes = xmlViewer.getElementsByTagName('rss');
            if (rssNodes.length > 0) {
                pvbb_transformRSSDoc();
            }
        }
    }
}

pvbb_pageInit();
